%version 4
warning off;
clear all;  
close all;
global DATA;
  initdata;
    dtime=DATA.dtime;
   	B=getdata;% visualise initdata
   	Param=B;
   B=load('bestin_16.dat'); %comment to see initial result
   Param=(B(end,:))';		     %comment also this to see initial result

    %********* Choice of display *******3
    HYP=1; % make images for animation auxin variation
	LEN=0; % visualize result
    VAL=0; % get values

  setdata(Param);
%*** init: A=AAI at each cell

  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit ;
Dbottom(:,[1,4])=DATA.Dbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.Dtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.Din*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.Dout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  
  cuml0=DATA.Qlight0;

%%% CL75 ****************************************
   if (1) %Col0
    DATA.lux = 75; % umol.m-2.s-1 Condition Light
    DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');
        dat=DATA.A_pKO1_2; %A: Col0; B: pin3; C: abcb
        datec=DATA.ecA_pKO1_2; %A: Col0; B: pin3; C: abcb
      DATA.mu=DATA.wtmu; %mu=0
   end
   
  
  
  if (0) %abcb
	  DATA.lux = 75; % umol.m-2.s-1 Condition Light
    DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');
	  DATA.mu=DATA.abcbmu; %mu=0
    dat=DATA.C_pKO2; %A: Col0; B: pin3; C: abcb
    datec=DATA.ecC_pKO2; %standard deviation A: Col0; B: pin3; C: abcb
  	Dbottom=DATA.mutDbottom2*ones(DATA.N,4);
  	Dtop=DATA.mutDtop2*ones(DATA.N,4);
  	Din=DATA.mutDin2*ones(DATA.N,4);
  	Dout=DATA.mutDout2*ones(DATA.N,4);
  	D=cat(3,Dtop,Dbottom,Dout,Din);
  end

   if (0) %sav3
    DATA.lux = 75; % umol.m-2.s-1 Condition Light
    DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');
    DATA.mu=DATA.savmu; %mu=0
    dat=DATA.D_pKO9; %A: Col0; B: pin3; C: abcb D: sav3
    datec=DATA.ecD_pKO9; %A: Col0; B: pin3; C: abcb  
   end
   
%*****************************   
%*** LD 130uE
   if (0) %Col0
     DATA.lux = 130; % umol.m-2.s-1 Condition Light
     DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x'); 
        dat=DATA.A_pKO3; %A: Col0; B: pin3; C: abcb
        datec=DATA.ecA_pKO3; %A: Col0; B: pin3; C: abcb
      DATA.mu=DATA.wtmu; %mu=0
   end
   
  
   if (0) %abcb
    DATA.lux = 130; % umol.m-2.s-1 Condition Light
    DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x'); 
    DATA.mu=DATA.abcbmu; %mu=0
    dat=DATA.C_pKO3; %A: Col0; B: pin3; C: abcb
    datec=DATA.ecC_pKO3; %standard deviation A: Col0; B: pin3; C: abcb
  	Dbottom=DATA.mutDbottom2*ones(DATA.N,4);
  	Dtop=DATA.mutDtop2*ones(DATA.N,4);
  	Din=DATA.mutDin2*ones(DATA.N,4);
  	Dout=DATA.mutDout2*ones(DATA.N,4);
  	D=cat(3,Dtop,Dbottom,Dout,Din);
   end
   
   if (0) %sav3
    DATA.lux = 130; % umol.m-2.s-1 Condition Light
    DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x'); 
    DATA.mu=DATA.savmu; %mu=0
    dat=DATA.D_pKO3; %A: Col0; B: pin3; C: abcb D: sav3
    datec=DATA.ecD_pKO3; %A: Col0; B: pin3; C: abcb
    
   end
  %*********************************************
%*** CL 130uE
   if (0) %Col0
     DATA.lux = 130; % umol.m-2.s-1 Condition Light
     DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');
     dat=DATA.A_pKO8; %A: Col0; B: pin3; C: abcb
     datec=DATA.ecA_pKO8; %A: Col0; B: pin3; C: abcb
     DATA.mu=DATA.wtmu; %mu=0
   end
   
  
  if (0) %abcb
    DATA.lux = 130; % umol.m-2.s-1 Condition Light
    DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');
    dat=DATA.C_pKO8; %A: Col0; B: pin3; C: abcb
    datec=DATA.ecC_pKO8; %standard deviation A: Col0; B: pin3; C: abcb
  	Dbottom=DATA.mutDbottom2*ones(DATA.N,4);
  	Dtop=DATA.mutDtop2*ones(DATA.N,4);
  	Din=DATA.mutDin2*ones(DATA.N,4);
  	Dout=DATA.mutDout2*ones(DATA.N,4);
  	D=cat(3,Dtop,Dbottom,Dout,Din);
    DATA.mu=DATA.abcbmu; %mu=0
  end
   
   if (0) %sav3
    DATA.lux = 130; % umol.m-2.s-1 Condition Light
    DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');
    dat=DATA.D_pKO8; %A: Col0; B: pin3; C: abcb D: sav3
    datec=DATA.ecD_pKO8; %A: Col0; B: pin3; C: abcb
    DATA.mu=DATA.savmu; %mu=0
   end

%%% LD75 ****************************************
   if (0) %Col0
    DATA.lux = 75; % umol.m-2.s-1 Condition Light
    DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x'); 
	  dat=DATA.A_pKO5; %A: Col0; B: pin3; C: abcb
    datec=DATA.ecA_pKO5; %A: Col0; B: pin3; C: abcb
    DATA.mu=DATA.wtmu; %mu=0


   end
   
  
  if (0) %abcb
	  DATA.lux = 75; % umol.m-2.s-1 Condition Light
    DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x'); 
	  DATA.mu=DATA.abcbmu; %mu=0
    dat=DATA.C_pKO5; %A: Col0; B: pin3; C: abcb
    datec=DATA.ecC_pKO5; %standard deviation A: Col0; B: pin3; C: abcb
 	  Dbottom=DATA.mutDbottom2*ones(DATA.N,4);
  	Dtop=DATA.mutDtop2*ones(DATA.N,4);
  	Din=DATA.mutDin2*ones(DATA.N,4);
  	Dout=DATA.mutDout2*ones(DATA.N,4);
  	D=cat(3,Dtop,Dbottom,Dout,Din);
  end

   if (0) %sav3
      DATA.lux = 75; % umol.m-2.s-1 Condition Light
      DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x'); 
      DATA.mu=DATA.savmu; %mu=0
      dat=DATA.D_pKO5; %A: Col0; B: pin3; C: abcb D: sav3
      datec=DATA.ecD_pKO5; %A: Col0; B: pin3; C: abcb
      
   end
%******************************* 

  
  if (VAL==1 || HYP==1 || LEN==1) clf; end
  
  
  
%*** init general data: no. of cells and boundary conditions:
  ncell =DATA.N;
  A = A0;

%--- time stepping: dtime=timestep, T=simulation times for Runge-Kutta:
  
  Tend=DATA.Tsim; %hours of simulation
  T = 0:DATA.dtime:Tend;
%--- tolerance for stationary solution: (if |dX|_infty < xtol --> stationary):
  xtol = 1e-6;
%--- sanity check for divergence:
  xmax = 1e30;
  

%*** init: A=AAI at each cell,l length of the cells, nb quantity of basal pin, nl  quantity of lateral pin  :
    

%*** model for hypocotyl auxin transport

  fprintf('=== hypocotyl auxin transport :\n');
  model = 'transport2Dnew';
  %initdata; 
  


  lg=l0;
%*** Runge-Kutta 4 method:
  ntime = length(T);
  l=l0;
  
  cumlight=DATA.Qlight0;
  
  if (VAL) 
      % init matrix of comparison sim - obs
      set(0,'CurrentFigure',fig2)
    [xde,yde]=meshgrid([0:DATA.N],[0:6]);
    derror=zeros(6+1,ncell+1);
         surf(xde,yde,derror);
         cb=colorbar;
         view(2);
         set(gca,'XLim',[0 DATA.N],'XTick',[0:DATA.N],'XtickLabel',{[],[1:DATA.N+1]});
         title('Absolute error (sim-obs)')
  end
  
         
  if (HYP)
           % init matrix of hypocotyl cells
           [xcel,ycel]=meshgrid([0:DATA.N],[0:4]); 
              
  end

  if (LEN)
           if (DATA.Tsim>=DATA.delayFR) %with FR
             maxlim=350;%round(max(dat(3,:)))+50;
           else
             maxlim=350;%round(max(dat(2,:)))+50;
           end
           y(1)=plot(1:ncell,l(:,1),'*r');%,'YLim',[0 180],'YTick',[0:20:180],
              hold on
           %y(2)=plot(1:ncell,dat(2,:)','*b');
           e(1)=errorbar(1:ncell,dat(2,1:ncell)',datec(2,1:ncell)','b');
           y(3)=plot(1:ncell,dat(3,1:ncell),'*g');
           e(2)=errorbar(1:ncell,dat(3,1:ncell),datec(3,1:ncell)','g');
           %y(4)=plot(1:ncell,dat(1,:),'*k');
           e(3)=errorbar(1:ncell,dat(1,1:ncell),datec(1,1:ncell)','k');
              hold off
           set(gca,'XLim',[0 DATA.N+1],'XTick',[0:DATA.N],'XtickLabel',{[],[1:DATA.N+1]},'YLim',[0 maxlim]); %,'YTick',[0:40:'auto']
           title('length of cells (um)')
  end


  for itime = 2:ntime
    t = T(itime-1);
    cumlight = cumlight+DATA.DN(t)*DATA.lux*dtime;  
    [k1,l1] = feval( model, cumlight,DATA.DN(t)*DATA.lux, t        ,A              ,l  ,D,Param);
    [k2,l2] = feval(model,  cumlight,DATA.DN(t+dtime/2)*DATA.lux, t+dtime/2,A+dtime/2.*k1,l+dtime/2.*l1,D,Param);
    [k3,l3] = feval(model,  cumlight,DATA.DN(t+dtime/2)*DATA.lux, t+dtime/2,A+dtime/2.*k2,l+dtime/2.*l2,D,Param);
    [k4,l4] = feval(model,  cumlight,DATA.DN(t+dtime)*DATA.lux, t+dtime  ,A+dtime.*k3,l+dtime.*l3,D,Param);
    l = l + dtime/6.*(l1 + 2*l2 + 2*l3 + l4);
    A = A + dtime/6.*(k1 + 2*k2 + 2*k3 + k4);
    
    if (min(min(A)) < 0 || min(min(l)) < 0)
      fprintf('### error - A or l are negative ! \n')
      break;
    end

    [dA,dl] = feval(model, cumlight,DATA.DN(t)*DATA.lux, t,A,l,D,Param); 

    if (VAL)
      set(0,'CurrentFigure',fig2)
      title(['Absolute error (sim-obs) ']);%
        if (DATA.Tsim>=DATA.delayFR)
            switch t
              case (4*24) % 4d
             derror(1,1:DATA.N)=(l(1:DATA.N,1)-dat(1,:)');
             surf(xde,yde,derror);
             cb=colorbar;
             view(2);
              case (6*24)  % 6d
             derror(2,1:DATA.N)=(l(1:DATA.N,1)-dat(3,:)');
             surf(xde,yde,derror);
             cb=colorbar;
             view(2);
            end
          elseif (DATA.Tsim<DATA.delayFR)
          switch t
             case (4*24) % 4d
                 derror(1,1:DATA.N)=(l(1:DATA.N,1)-dat(1,:)');
                 surf(xde,yde,derror);
                 cb=colorbar;
                 view(2);
             case (6*24) % 6d
                 derror(2,1:DATA.N)=(l(1:DATA.N,1)-dat(2,:)');
                 surf(xde,yde,derror);
                 cb=colorbar;
                 view(2);
          end
   
   
        end
   end

    
    if (HYP)
        hyp=vertcat(log(A(DATA.N:-1:1,:)),zeros(1,4));
        hyp=horzcat(hyp,zeros(DATA.N+1,1));
        h=subplot(2,1,1); %,'Position',[.13, .5795, .775,.3455]
         surf(xcel,ycel,hyp');
                  view(2);
                  colorbar;
				   set(gca,'XLim',[1 DATA.N-1],'YLim',[0 4],'YTick',[],'XTick',[]); %,'ZLim',[-18 -6]
                title(['Auxin distribution and cellular growth <> time: ',num2str(t/24.0,'%2.2f'),' days ']);%  
				
set(gcf,'renderer','painters')
         k=subplot(2,1,2); %,,'Position',[.13, .11, .654,.3375]
		 ax=get(k,'Position');
		 ax(3)=ax(3)-.121;
		 set(k,'Position',ax);
         stem(1:DATA.N-1,l(DATA.N-1:-1:1),'or',"markerfacecolor",'r');
         set(gca,'XTick',[1:18], 'YTick',[0:50:250], 'YLim', [0 250])
		 xlim([0 DATA.N])
     xlabel("Cell position (from top)",'FontSize',12)

		 drawnow
     
	 if (0) %Switch to 1 to save images
	filename=sprintf('./im/Hyp4_bestin16_%06d.png', itime);
	print (gcf, filename) %octave
  %imwrite(gcf,filename)	%Matlab

        end	 
        
    end


          
      %     if (rem(itime,1000)==0)
      %       fprintf('time: %e [%d/%d]    |dA|: %e |dl| : %e\n', ...
      %           t,itime,ntime, norm(dA,inf),norm(dl,inf)); 
      %     end

        %--- visu:  
      %     visuhypocotyl(A,l,1);

      %--- stopping condition for stationary iteration:
          if (norm(dA,inf)<xtol)
            fprintf('*** process has reached stationa(9.6*24)ry solution, iteration done\n');
            break;
          end
          if ((norm(A,inf)>xmax) || (norm(dA,inf)>xmax) || sum(sum(isnan(A))) || sum(sum(isnan(dA))))
            fprintf('### error - it REALLY diverges: try to decrease (dtime) and pray...\n');
            break;
          end
  end

  
    if (LEN)
        vl=l(end:-1:1,:);
        vlg=lg(end:-1:1);
          if (DATA.Tsim<DATA.delayFR)
          set(y(1),'YData',vl(:,4));set(y(3),'YData',vlg);
          else
          set(y(1),'YData',vl(:,4));set(y(3),'YData',vlg);  
          end
    end


