%version 4: independant Permeabilities. Debugged

clear all;  
%Xt=zeros(48,20);
global DATA;
  initdata;
  dtime=DATA.dtime;
   	B=getdata;% visualise initdata
   	Param=B;
   B=load('bestin_16.dat'); 
   Param=(B(end,:))';
   	
nbparam=length(Param);
boil=0.01; % 


 %*** open files: for pareto

Wtarget = ones(3,DATA.N); %*** weight associed to the target solution
Wexp1a(1:3,1:DATA.N) = 1;  %*** weight for experiment CL75 Col0 (1: 0.01; 5: 0.2)
Wexp1b(1:3,1:DATA.N) = 1;  %*** weight for experiment CL75 pin3.5 (1: 0.03)
Wexp1c(1:3,1:DATA.N) = 1;  %*** weight for experiment CL75 abcb1/19
Wexp1d(1:3,1:DATA.N) = 1;  %*** weight for experiment CL75 sav3
Wexp2a(1:3,1:DATA.N) = 1;  %*** weight for experiment LD130 Col0
Wexp2b(1:3,1:DATA.N) = 1;  %*** weight for experiment LD130 pin3.5
Wexp2c(1:3,1:DATA.N) = 1;  %*** weight for experiment LD130 abcb1/19
Wexp2d(1:3,1:DATA.N) = 1;  %*** weight for experiment LD130 sav3
Wexp3a(1:3,1:DATA.N) = 1;  %*** weight for experiment CL130 Col0
Wexp3b(1:3,1:DATA.N) = 1;  %*** weight for experiment CL130 pin3.5
Wexp3c(1:3,1:DATA.N) = 1;  %*** weight for experiment CL130 abcb1/19
Wexp3d(1:3,1:DATA.N) = 1;  %*** weight for experiment CL130 sav3
Wexp4a(1:3,1:DATA.N) = 1;  %*** weight for experiment LD75 Col0 
Wexp4b(1:3,1:DATA.N) = 1;  %*** weight for experiment LD75 pin3.5 
Wexp4c(1:3,1:DATA.N) = 1;  %*** weight for experiment LD75 abcb1/19
Wexp4d(1:3,1:DATA.N) = 1;  %*** weight for experiment LD75 sav3

%*** first run:
DATA.Xtarget = [];
DATA.Wtarget = [];
  
%----------------------------------------------------------------------------------------------------------------------------   
%CL 75uE
%*** Experimental dataset for DATA.A_pKO1_2  (Col0)
A_pKO1_2=DATA.A_pKO1_2;  
ecA_pKO1_2=DATA.ecA_pKO1_2;
%*** Experimental dataset for DATA.A_pKO1  (pin3)
B_pKO1=DATA.B_pKO1;  
ecB_pKO1=DATA.ecB_pKO1;
%*** Experimental dataset for DATA.C_pKO2   (abcb)
C_pKO2=DATA.C_pKO2;
ecC_pKO2=DATA.ecC_pKO2;
%*** Experimental dataset for DATA.D_pKO9   (sav3)
D_pKO9=DATA.D_pKO9;
ecD_pKO9=DATA.ecD_pKO9;

%LD 130uE
%*** Experimental dataset for DATA.A_pKO3  (Col0)
A_pKO3=DATA.A_pKO3;  

ecA_pKO3=DATA.ecA_pKO3;
%*** Experimental dataset for DATA.B_pKO3  (pin3.5)
B_pKO3=DATA.B_pKO3;  
ecB_pKO3=DATA.ecB_pKO3;
%*** Experimental dataset for DATA.C_pKO3   (abcb1/abcb19)
C_pKO3=DATA.C_pKO3;
ecC_pKO3=DATA.ecC_pKO3;
%*** Experimental dataset for DATA.C_pKO3   (abcb1/abcb19)
D_pKO3=DATA.D_pKO3;
ecD_pKO3=DATA.ecD_pKO3;

%CL 130uE
%*** Experimental dataset for DATA.A_pKO8  (Col0)
A_pKO8=DATA.A_pKO8;  
ecA_pKO8=DATA.ecA_pKO8;
%*** Experimental dataset for DATA.B_pKO8  (pin3.5)
B_pKO8=DATA.B_pKO8;  
ecB_pKO8=DATA.ecB_pKO8;
%*** Experimental dataset for DATA.C_pKO8   (abcb1/abcb19)
C_pKO8=DATA.C_pKO8;
ecC_pKO8=DATA.ecC_pKO8;
%*** Experimental dataset for DATA.C_pKO8   (abcb1/abcb19)
D_pKO8=DATA.D_pKO8;
ecD_pKO8=DATA.ecD_pKO8;

%LD 75uE
%*** Experimental dataset for DATA.A_pKO1_2  (Col0)
A_pKO5=DATA.A_pKO5;  
ecA_pKO5=DATA.ecA_pKO5;
%*** Experimental dataset for DATA.A_pKO1  (pin3)
B_pKO5=DATA.B_pKO5;  
ecB_pKO5=DATA.ecB_pKO5;
%*** Experimental dataset for DATA.C_pKO5   (abcb)
C_pKO5=DATA.C_pKO5;
ecC_pKO5=DATA.ecC_pKO5;
%*** Experimental dataset for DATA.D_pKO5   (sav3)
D_pKO5=DATA.D_pKO5;
ecD_pKO5=DATA.ecD_pKO5;


 % ---Col0: CL 75uE white light
 DATA.Xtarget{1}= ones(3,DATA.N);
 DATA.Wtarget{1}= Wtarget;
 DATA.Xtarget{1}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{1}(1,1:DATA.N) = A_pKO1_2(1,1:DATA.N);
 DATA.Wtarget{1}(1,1:DATA.N) = 1+log10(A_pKO1_2(1,1:DATA.N)./ecA_pKO1_2(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{1}(2,1:DATA.N) = A_pKO1_2(2,1:DATA.N);
 DATA.Wtarget{1}(2,1:DATA.N) = 1+log10(A_pKO1_2(2,1:DATA.N)./ecA_pKO1_2(2,1:DATA.N));

 % time point day 6 with FR
 DATA.Xtarget{1}(3,1:DATA.N) = A_pKO1_2(3,1:DATA.N);
 DATA.Wtarget{1}(3,1:DATA.N) = 1+log10(A_pKO1_2(3,1:DATA.N)./ecA_pKO1_2(3,1:DATA.N));
 
 % ---pin3.5: CL 75uE white light
 DATA.Xtarget{2}= ones(3,DATA.N);
 DATA.Wtarget{2}= Wtarget;
 DATA.Xtarget{2}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{2}(1,1:DATA.N) = B_pKO1(1,1:DATA.N);
 DATA.Wtarget{2}(1,1:DATA.N) = 1+log10(B_pKO1(1,1:DATA.N)./ecB_pKO1(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{2}(2,1:DATA.N) = B_pKO1(2,1:DATA.N);
 DATA.Wtarget{2}(2,1:DATA.N) = 1+log10(B_pKO1(2,1:DATA.N)./ecB_pKO1(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{2}(3,1:DATA.N) = B_pKO1(3,1:DATA.N);
 DATA.Wtarget{2}(3,1:DATA.N) = 1+log10(B_pKO1(3,1:DATA.N)./ecB_pKO1(3,1:DATA.N));
 
 % ---abcb1/abcb19: CL 75uE white light
 DATA.Xtarget{3}= ones(3,DATA.N);
 DATA.Wtarget{3}= Wtarget;
 DATA.Xtarget{3}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{3}(1,1:DATA.N) = C_pKO2(1,1:DATA.N);
 DATA.Wtarget{3}(1,1:DATA.N) = 1+log10(C_pKO2(1,1:DATA.N)./ecC_pKO2(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{3}(2,1:DATA.N) = C_pKO2(2,1:DATA.N);
 DATA.Wtarget{3}(2,1:DATA.N) = 1+log10(C_pKO2(2,1:DATA.N)./ecC_pKO2(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{3}(3,1:DATA.N) = C_pKO2(3,1:DATA.N);
 DATA.Wtarget{3}(3,1:DATA.N) = 1+log10(C_pKO2(3,1:DATA.N)./ecC_pKO2(3,1:DATA.N));
 
% ---sav3: CL 75uE white light
 DATA.Xtarget{4}= ones(3,DATA.N);
 DATA.Wtarget{4}= Wtarget;
 DATA.Xtarget{4}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{4}(1,1:DATA.N) = D_pKO9(1,1:DATA.N);
 DATA.Wtarget{4}(1,1:DATA.N) = 1+log10(D_pKO9(1,1:DATA.N)./ecD_pKO9(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{4}(2,1:DATA.N) = D_pKO9(2,1:DATA.N);
 DATA.Wtarget{4}(2,1:DATA.N) = 1+log10(D_pKO9(2,1:DATA.N)./ecD_pKO9(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{4}(3,1:DATA.N) = D_pKO9(3,1:DATA.N);
 DATA.Wtarget{4}(3,1:DATA.N) = 1+log10(D_pKO9(3,1:DATA.N)./ecD_pKO9(3,1:DATA.N));

%&&&&&&&&&&
% ---Col0: LD 130uE white light
 DATA.Xtarget{5}= ones(3,DATA.N);
 DATA.Wtarget{5}= Wtarget;
 DATA.Xtarget{5}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{5}(1,1:DATA.N) = A_pKO3(1,1:DATA.N);
 DATA.Wtarget{5}(1,1:DATA.N) = 1+log10(A_pKO3(1,1:DATA.N)./ecA_pKO3(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{5}(2,1:DATA.N) = A_pKO3(2,1:DATA.N);
 DATA.Wtarget{5}(2,1:DATA.N) = 1+log10(A_pKO3(2,1:DATA.N)./ecA_pKO3(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{5}(3,1:DATA.N) = A_pKO3(3,1:DATA.N);
 DATA.Wtarget{5}(3,1:DATA.N) = 1+log10(A_pKO3(3,1:DATA.N)./ecA_pKO3(3,1:DATA.N));
 
 % ---pin3.5: LD 130uE white light
 DATA.Xtarget{6}= ones(3,DATA.N);
 DATA.Wtarget{6}= Wtarget;
 DATA.Xtarget{6}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{6}(1,1:DATA.N) = B_pKO3(1,1:DATA.N);
 DATA.Wtarget{6}(1,1:DATA.N) = 1+log10(B_pKO3(1,1:DATA.N)./ecB_pKO3(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{6}(2,1:DATA.N) = B_pKO3(2,1:DATA.N);
 DATA.Wtarget{6}(2,1:DATA.N) = 1+log10(B_pKO3(2,1:DATA.N)./ecB_pKO3(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{6}(3,1:DATA.N) = B_pKO3(3,1:DATA.N);
 DATA.Wtarget{6}(3,1:DATA.N) = 1+log10(B_pKO3(3,1:DATA.N)./ecB_pKO3(3,1:DATA.N));
 
 % ---abcb1/abcb19: LD 130uE white light
 DATA.Xtarget{7}= ones(3,DATA.N);
 DATA.Wtarget{7}= Wtarget;
 DATA.Xtarget{7}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{7}(1,1:DATA.N) = C_pKO3(1,1:DATA.N);
 DATA.Wtarget{7}(1,1:DATA.N) = 1+log10(C_pKO3(1,1:DATA.N)./ecC_pKO3(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{7}(2,1:DATA.N) = C_pKO3(2,1:DATA.N);
 DATA.Wtarget{7}(2,1:DATA.N) = 1+log10(C_pKO3(2,1:DATA.N)./ecC_pKO3(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{7}(3,1:DATA.N) = C_pKO3(3,1:DATA.N);
 DATA.Wtarget{7}(3,1:DATA.N) = 1+log10(C_pKO3(3,1:DATA.N)./ecC_pKO3(3,1:DATA.N));

 % ---sav3: LD 130uE white light
 DATA.Xtarget{8}= ones(3,DATA.N);
 DATA.Wtarget{8}= Wtarget;
 DATA.Xtarget{8}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{8}(1,1:DATA.N) = D_pKO3(1,1:DATA.N);
 DATA.Wtarget{8}(1,1:DATA.N) = 1+log10(D_pKO3(1,1:DATA.N)./ecD_pKO3(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{8}(2,1:DATA.N) = D_pKO3(2,1:DATA.N);
 DATA.Wtarget{8}(2,1:DATA.N) = 1+log10(D_pKO3(2,1:DATA.N)./ecD_pKO3(2,1:DATA.N));

 % time point day 6 with FR
 DATA.Xtarget{8}(3,1:DATA.N) = D_pKO3(3,1:DATA.N);
 DATA.Wtarget{8}(3,1:DATA.N) = 1+log10(D_pKO3(3,1:DATA.N)./ecD_pKO3(3,1:DATA.N));
%&&&&&&&&&&&&&&&& 

%&&&&&&&&&&
% ---Col0: CL 130uE white light
 DATA.Xtarget{9}= ones(3,DATA.N);
 DATA.Wtarget{9}= Wtarget;
 DATA.Xtarget{9}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{9}(1,1:DATA.N) = A_pKO8(1,1:DATA.N);
 DATA.Wtarget{9}(1,1:DATA.N) = 1+log10(A_pKO8(1,1:DATA.N)./ecA_pKO8(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{9}(2,1:DATA.N) = A_pKO8(2,1:DATA.N);
 DATA.Wtarget{9}(2,1:DATA.N) = 1+log10(A_pKO8(2,1:DATA.N)./ecA_pKO8(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{9}(3,1:DATA.N) = A_pKO8(3,1:DATA.N);
 DATA.Wtarget{9}(3,1:DATA.N) = 1+log10(A_pKO8(3,1:DATA.N)./ecA_pKO8(3,1:DATA.N));
 
 % ---pin3.5: CL 130uE white light
 DATA.Xtarget{10}= ones(3,DATA.N);
 DATA.Wtarget{10}= Wtarget;
 DATA.Xtarget{10}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{10}(1,1:DATA.N) = B_pKO8(1,1:DATA.N);
 DATA.Wtarget{10}(1,1:DATA.N) = 1+log10(B_pKO8(1,1:DATA.N)./ecB_pKO8(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{10}(2,1:DATA.N) = B_pKO8(2,1:DATA.N);
 DATA.Wtarget{10}(2,1:DATA.N) = 1+log10(B_pKO8(2,1:DATA.N)./ecB_pKO8(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{10}(3,1:DATA.N) = B_pKO8(3,1:DATA.N);
 DATA.Wtarget{10}(3,1:DATA.N) = 1+log10(B_pKO8(3,1:DATA.N)./ecB_pKO8(3,1:DATA.N));
 
 % ---abcb1/abcb19: CL 130uE white light
 DATA.Xtarget{11}= ones(3,DATA.N);
 DATA.Wtarget{11}= Wtarget;
 DATA.Xtarget{11}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{11}(1,1:DATA.N) = C_pKO8(1,1:DATA.N);
 DATA.Wtarget{11}(1,1:DATA.N) = 1+log10(C_pKO8(1,1:DATA.N)./ecC_pKO8(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{11}(2,1:DATA.N) = C_pKO8(2,1:DATA.N);
 DATA.Wtarget{11}(2,1:DATA.N) = 1+log10(C_pKO8(2,1:DATA.N)./ecC_pKO8(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{11}(3,1:DATA.N) = C_pKO8(3,1:DATA.N);
 DATA.Wtarget{11}(3,1:DATA.N) = 1+log10(C_pKO8(3,1:DATA.N)./ecC_pKO8(3,1:DATA.N));

 % ---sav3: CL 130uE white light
 DATA.Xtarget{12}= ones(3,DATA.N);
 DATA.Wtarget{12}= Wtarget;
 DATA.Xtarget{12}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{12}(1,1:DATA.N) = D_pKO8(1,1:DATA.N);
 DATA.Wtarget{12}(1,1:DATA.N) = 1+log10(D_pKO8(1,1:DATA.N)./ecD_pKO8(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{12}(2,1:DATA.N) = D_pKO8(2,1:DATA.N);
 DATA.Wtarget{12}(2,1:DATA.N) = 1+log10(D_pKO8(2,1:DATA.N)./ecD_pKO8(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{12}(3,1:DATA.N) = D_pKO8(3,1:DATA.N);
 DATA.Wtarget{12}(3,1:DATA.N) = 1+log10(D_pKO8(3,1:DATA.N)./ecD_pKO8(3,1:DATA.N));
%&&&&&&&&&&&&&&&& 

%&&&&&&&&&&
% ---Col0: LD 75uE white light
 DATA.Xtarget{13}= ones(3,DATA.N);
 DATA.Wtarget{13}= Wtarget;
 DATA.Xtarget{13}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{13}(1,1:DATA.N) = A_pKO5(1,1:DATA.N);
 DATA.Wtarget{13}(1,1:DATA.N) = 1+log10(A_pKO5(1,1:DATA.N)./ecA_pKO5(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{13}(2,1:DATA.N) = A_pKO5(2,1:DATA.N);
 DATA.Wtarget{13}(2,1:DATA.N) = 1+log10(A_pKO5(2,1:DATA.N)./ecA_pKO5(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{13}(3,1:DATA.N) = A_pKO5(3,1:DATA.N);
 DATA.Wtarget{13}(3,1:DATA.N) = 1+log10(A_pKO5(3,1:DATA.N)./ecA_pKO5(3,1:DATA.N));
 
 % ---pin3.5: LD 75uE white light
 DATA.Xtarget{14}= ones(3,DATA.N);
 DATA.Wtarget{14}= Wtarget;
 DATA.Xtarget{14}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{14}(1,1:DATA.N) = B_pKO5(1,1:DATA.N);
 DATA.Wtarget{14}(1,1:DATA.N) = 1+log10(B_pKO5(1,1:DATA.N)./ecB_pKO5(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{14}(2,1:DATA.N) = B_pKO5(2,1:DATA.N);
 DATA.Wtarget{14}(2,1:DATA.N) = 1+log10(B_pKO5(2,1:DATA.N)./ecB_pKO5(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{14}(3,1:DATA.N) = B_pKO5(3,1:DATA.N);
 DATA.Wtarget{14}(3,1:DATA.N) = 1+log10(B_pKO5(3,1:DATA.N)./ecB_pKO5(3,1:DATA.N));
 
 % ---abcb1/abcb19: LD 75uE white light
 DATA.Xtarget{15}= ones(3,DATA.N);
 DATA.Wtarget{15}= Wtarget;
 DATA.Xtarget{15}(3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{15}(1,1:DATA.N) = C_pKO5(1,1:DATA.N);
 DATA.Wtarget{15}(1,1:DATA.N) = 1+log10(C_pKO5(1,1:DATA.N)./ecC_pKO5(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{15}(2,1:DATA.N) = C_pKO5(2,1:DATA.N);
 DATA.Wtarget{15}(2,1:DATA.N) = 1+log10(C_pKO5(2,1:DATA.N)./ecC_pKO5(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{15}(3,1:DATA.N) = C_pKO5(3,1:DATA.N);
 DATA.Wtarget{15}(3,1:DATA.N) = 1+log10(C_pKO5(3,1:DATA.N)./ecC_pKO5(3,1:DATA.N));

 % ---sav3: LD 75uE white light
 DATA.Xtarget{16}= ones(3,DATA.N);
 DATA.Wtarget{16}= Wtarget;
 DATA.Xtarget{16}(1:3,1:DATA.N) = NaN;
 % time point day 4
 DATA.Xtarget{16}(1,1:DATA.N) = D_pKO5(1,1:DATA.N);
 DATA.Wtarget{16}(1,1:DATA.N) = 1+log10(D_pKO5(1,1:DATA.N)./ecD_pKO5(1,1:DATA.N));
 % time point day 6
 DATA.Xtarget{16}(2,1:DATA.N) = D_pKO5(2,1:DATA.N);
 DATA.Wtarget{16}(2,1:DATA.N) = 1+log10(D_pKO5(2,1:DATA.N)./ecD_pKO5(2,1:DATA.N));
 % time point day 6 with FR
 DATA.Xtarget{16}(3,1:DATA.N) = D_pKO5(3,1:DATA.N);
 DATA.Wtarget{16}(3,1:DATA.N) = 1+log10(D_pKO5(3,1:DATA.N)./ecD_pKO5(3,1:DATA.N));
%&&&&&&&&&&&&&&&& 


 %------------------Experiments weight-----------------
 DATA.Wtarget{1}(find(isnan(DATA.Wtarget{1})))=1;
 DATA.Wtarget{2}(find(isnan(DATA.Wtarget{2})))=1;
 DATA.Wtarget{3}(find(isnan(DATA.Wtarget{3})))=1;
 DATA.Wtarget{4}(find(isnan(DATA.Wtarget{4})))=1;
 DATA.Wtarget{5}(find(isnan(DATA.Wtarget{5})))=1;
 DATA.Wtarget{6}(find(isnan(DATA.Wtarget{6})))=1;
 DATA.Wtarget{7}(find(isnan(DATA.Wtarget{7})))=1;
 DATA.Wtarget{8}(find(isnan(DATA.Wtarget{8})))=1;
 DATA.Wtarget{9}(find(isnan(DATA.Wtarget{9})))=1;
 DATA.Wtarget{10}(find(isnan(DATA.Wtarget{10})))=1;
 DATA.Wtarget{11}(find(isnan(DATA.Wtarget{11})))=1;
 DATA.Wtarget{12}(find(isnan(DATA.Wtarget{12})))=1;
 DATA.Wtarget{13}(find(isnan(DATA.Wtarget{13})))=1;
 DATA.Wtarget{14}(find(isnan(DATA.Wtarget{14})))=1;
 DATA.Wtarget{15}(find(isnan(DATA.Wtarget{15})))=1;
 DATA.Wtarget{16}(find(isnan(DATA.Wtarget{16})))=1;

if (0) %with Std
  DATA.Wtarget{1} = Wexp1a.*DATA.Wtarget{1}; %CL75
  DATA.Wtarget{2} = Wexp1b.*DATA.Wtarget{2};
  DATA.Wtarget{3} = Wexp1c.*DATA.Wtarget{3};
  DATA.Wtarget{4} = Wexp1d.*DATA.Wtarget{4};
  DATA.Wtarget{5} = Wexp2a.*DATA.Wtarget{5}; %LD130
  DATA.Wtarget{6} = Wexp2b.*DATA.Wtarget{6};
  DATA.Wtarget{7} = Wexp2c.*DATA.Wtarget{7};
  DATA.Wtarget{8} = Wexp2d.*DATA.Wtarget{8};
  DATA.Wtarget{9} = Wexp3a.*DATA.Wtarget{9}; %CL130
  DATA.Wtarget{10} = Wexp3b.*DATA.Wtarget{10};
  DATA.Wtarget{11} = Wexp3c.*DATA.Wtarget{11};
  DATA.Wtarget{12} = Wexp3d.*DATA.Wtarget{12};
  DATA.Wtarget{13} = Wexp4a.*DATA.Wtarget{13}; %LD75
  DATA.Wtarget{14} = Wexp4b.*DATA.Wtarget{14};
  DATA.Wtarget{15} = Wexp4c.*DATA.Wtarget{15};
  DATA.Wtarget{16} = Wexp4d.*DATA.Wtarget{16};
else %without Std
  DATA.Wtarget{1} = Wtarget; %CL75
  DATA.Wtarget{2} = Wtarget;
  DATA.Wtarget{3} = Wtarget;
  DATA.Wtarget{4} = Wtarget;
  DATA.Wtarget{5} = Wtarget; %LD130
  DATA.Wtarget{6} = Wtarget;
  DATA.Wtarget{7} = Wtarget;
  DATA.Wtarget{8} = Wtarget;
  DATA.Wtarget{9} = Wtarget; %CL130
  DATA.Wtarget{10} = Wtarget;
  DATA.Wtarget{11} = Wtarget;
  DATA.Wtarget{12} = Wtarget;
  DATA.Wtarget{13} = Wtarget; %LD75
  DATA.Wtarget{14} = Wtarget;
  DATA.Wtarget{15} = Wtarget;
  DATA.Wtarget{16} = Wtarget;
end;
%-------------------------------------------------------

% ======================================================================
fprintf('=== Sensitivity :\n');
for s=1:nbparam
	Paramod=Param;
	Jneg=[];
	JnegV=[];
	for sneg=-1:2:1
Paramod(s)=Param(s)+Param(s).*sneg.*boil; %  one parametre variation
  setdata(Paramod);


%*** init: A=AAI at each cell

  A0     = zeros(DATA.N,4);
  A0(:,:) =DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; 
    J=0;
    Jv=0;	
 
 %strtrim(sprintf('%d ',Paramod(:)))
  cuml0=DATA.Qlight0;


if(1)  
  %*** A_pKO1_2: Col_0 CL 75uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  
 %DATA.photop=2; %define photoperiod 0: dark; 1: 16:8(L:D); 2: continuous light;  
  DATA.lux = 75; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)
  %---continuous:
  DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
%*** init: A=AAI at each cell
	
  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
  Dbottom(:,[1,4])=DATA.Dbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.Dtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.Din*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.Dout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;
  DATA.mu=DATA.wtmu;
  %quantity=sum(sum(A0.*l));
%*** 

  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;
%strtrim(sprintf('%d ',init0{1}))
   [Ct, state] = growth(T, Paramod,init0);


  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
  vLd=Ld(:,end:-1:1);
  
  %weight=0.1; %1e-3; %1e-31;

%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{1}))
      Xtarget = DATA.Xtarget{1}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{1}(:,1:DATA.N-1);

      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2;

        end;
      end;
   end;
   
 %Xt(1,:)=vLd(1,:);
 %Xt(2,:)=vLd(2,:);
 
 %*** A_pKO1_2: Col_0 CL 75uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;   
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
  %---continuous:
   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
  vLd(3,:)=Ld(3,end:-1:1);


%*** calculate the cost-function (for every Xtarget which <> NaN):
if (~isempty(DATA.Xtarget{1}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 
        end;
      
   end;
   
    %************************
  %plot(1:20,DATA.A_pKO1_2(1,:),'b*',1:20,vLd(1,:),1:20,DATA.A_pKO1_2(2,:),'g*',1:20,vLd(2,:),1:20,DATA.A_pKO1_2(3,:),'r*',1:20,vLd(3,:));
%************************

 %Xt(3,:)=vLd(3,:);
end;




if(1) 
%----------- knock-out plant: abcb1/abcb19-KO -----
%*** C_pKO2: abcb CL 75uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  

  DATA.lux = 75; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)

  %---continuous:
  DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
%*** init: A=AAI at each cell

  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
 Dbottom(:,[1,4])=DATA.abcbDbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.abcbDtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.abcbDin*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.abcbDout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;
  
  %*** effect of mutation abcb 
  DATA.mu=DATA.abcbmu;
  
  
  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;
  
   [Ct, state] = growth(T, Paramod,init0);
  
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
   vLd=Ld(:,end:-1:1);
   
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{3}))
      Xtarget = DATA.Xtarget{3}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{3}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2;
        end;
      end;
   end;
 
 

 
 %Xt(7,:)=vLd(1,:);
 %Xt(8,:)=vLd(2,:);
 
 %*** C_pKO2: abcb CL 75uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;    
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
  
  luxDN = DATA.DN(T).*DATA.lux;
  
  

  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
  vLd(3,:)=Ld(3,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{3}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 
        end;
      
   end;
  
 %Xt(9,:)=vLd(3,:);
%DATA.mu=Pold(1); %restaure mu0
 end;


if(1) 
%----------- knock-out plant: sav3-KO -----
%*** D_pKO9: sav CL 75uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  

  DATA.lux = 75; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)
  
 
  %---continuous:
  DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
Dbottom(:,[1,4])=DATA.Dbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.Dtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.Din*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.Dout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;

  %*** effect of mutation sav3
 DATA.mu=DATA.savmu;

  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;
  
   [Ct, state] = growth(T, Paramod,init0);
  
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
  vLd=Ld(:,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{4}))
      Xtarget = DATA.Xtarget{4}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{4}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2; 
        end;
      end;
   end;
 

 
 %Xt(10,:)=vLd(1,:);
 %Xt(11,:)=vLd(2,:);
 
 %*** C_pKO8: sav3 CL 75uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;    
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
 
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
  vLd(3,:)=Ld(3,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{4}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 
        end;
      
   end;
 
 %Xt(12,:)=vLd(3,:);

end;


%&&&&&&&&&&&&&&&&& LD 130uE &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
if(1)
  %*** A_pKO3: Col_0 LD 130uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  
 %DATA.photop=2; %define photoperiod 0: dark; 1: 16:8(L:D); 2: continuous light;  
  DATA.lux = 130; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)
  %---Long day light:
  DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
 %*** init: A=AAI at each cell

  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
Dbottom(:,[1,4])=DATA.Dbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.Dtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.Din*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.Dout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;
  DATA.mu=DATA.wtmu;
  %quantity=sum(sum(A0.*l));
%*** 

  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;

   [Ct, state] = growth(T, Paramod,init0);
  
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
  vLd=Ld(:,end:-1:1);
  
  %weight=0.1; %1e-3; %1e-31;

%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{5}))
      Xtarget = DATA.Xtarget{5}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{5}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2; 

        end;
      end;
   end;
   
 %Xt(13,:)=vLd(1,:);
 %Xt(14,:)=vLd(2,:);
 
 %*** A_pKO8: Col_0 CL 130uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;   
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
  %---continuous:
   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
   vLd(3,:)=Ld(3,end:-1:1);
 
%*** calculate the cost-function (for every Xtarget which <> NaN):
if (~isempty(DATA.Xtarget{5}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 

        end;
      
   end;
   
 %Xt(15,:)=vLd(3,:);

end;



if(1) 
%----------- knock-out plant: abcb1/abcb19-KO -----
%*** C_pKO3: abcb LD 130uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  
 %DATA.photop=2; %define photoperiod 0: dark; 1: 16:8(L:D); 2: continuous light;  
  DATA.lux = 130; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)
  
 %---Long day light:
  DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x');    
  luxDN = DATA.DN(T).*DATA.lux;
  
  %** init: A=AAI at each cell

  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
Dbottom(:,[1,4])=DATA.abcbDbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.abcbDtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.abcbDin*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.abcbDout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;


    %*** effect of mutation abcb
  DATA.mu=DATA.abcbmu;

  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;
  
   [Ct, state] = growth(T, Paramod,init0);
  
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
   vLd=Ld(:,end:-1:1);
  
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{7}))
      Xtarget = DATA.Xtarget{7}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{7}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2; 

        end;
      end;
   end;
 
 %Xt(19,:)=vLd(1,:);
 %Xt(20,:)=vLd(2,:);
 
 %*** C_pKO2: abcb LD 130uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;    
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
  
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default

  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
  vLd(3,:)=Ld(3,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{7}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 

        end;
      
   end;
   
 %Xt(21,:)=vLd(3,:);

end;

if(1) 
%----------- knock-out plant: sav3-KO -----
%*** D_pKO3: sav LD 130uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  
 %DATA.photop=2; %define photoperiod 0: dark; 1: 16:8(L:D); 2: continuous light;  
  DATA.lux = 130; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)
  
 
  %---Long day light:
  DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
Dbottom(:,[1,4])=DATA.Dbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.Dtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.Din*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.Dout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;
  
   %*** effect of mutation sav3
  DATA.mu=DATA.savmu;

  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;
  
   [Ct, state] = growth(T, Paramod,init0);
  
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
  vLd=Ld(:,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{8}))
      Xtarget = DATA.Xtarget{8}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{8}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2; 
        end;
      end;
   end;
 
 %Xt(22,:)=vLd(1,:);
 %Xt(23,:)=vLd(2,:);
 
 %*** C_pKO8: sav3 CL 130uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;    
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
  vLd(3,:)=Ld(3,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{8}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 
        end;
      
   end;
   
 %Xt(24,:)=vLd(3,:);

end;
%&&&&&&&&&&&&&&&&&

%&&&&&&&&&&&&&&&&& CL 130uE &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
if(1) 
  %*** A_pKO8: Col_0 CL 130uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  
 %DATA.photop=2; %define photoperiod 0: dark; 1: 16:8(L:D); 2: continuous light;  
  DATA.lux = 130; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)
  %---continuous:
  DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
 %*** init: A=AAI at each cell

  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
Dbottom(:,[1,4])=DATA.Dbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.Dtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.Din*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.Dout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;
  DATA.mu=DATA.wtmu;
  %quantity=sum(sum(A0.*l));
%*** 

  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;

   [Ct, state] = growth(T, Paramod,init0);
  
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
  vLd=Ld(:,end:-1:1);
  
  %weight=0.1; %1e-3; %1e-31;

%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{9}))
      Xtarget = DATA.Xtarget{9}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{9}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2; 
        end;
      end;
   end;
   
 %Xt(25,:)=vLd(1,:);
 %Xt(26,:)=vLd(2,:);
 
 %*** A_pKO8: Col_0 CL 130uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;   
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
  %---continuous:
   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
   vLd(3,:)=Ld(3,end:-1:1);
 
%*** calculate the cost-function (for every Xtarget which <> NaN):
if (~isempty(DATA.Xtarget{9}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 
        end;
      
   end;
   
 %Xt(27,:)=vLd(3,:);

end;



if(1)
%----------- knock-out plant: abcb1/abcb19-KO -----
%*** C_pKO2: abcb CL 130uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  
 %DATA.photop=2; %define photoperiod 0: dark; 1: 16:8(L:D); 2: continuous light;  
  DATA.lux = 130; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)
  
  %---continuous:
  DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
  %** init: A=AAI at each cell

  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
Dbottom(:,[1,4])=DATA.abcbDbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.abcbDtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.abcbDin*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.abcbDout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;
  

    %*** effect of mutation abcb
 DATA.mu=DATA.abcbmu;

  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;
  
   [Ct, state] = growth(T, Paramod,init0);
  
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
   vLd=Ld(:,end:-1:1);
  
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{11}))
      Xtarget = DATA.Xtarget{11}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{11}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
Jv = Jv + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2; 
        end;
      end;
   end;
 
 %Xt(31,:)=vLd(1,:);
 %Xt(32,:)=vLd(2,:);
 
 %*** C_pKO2: abcb CL 130uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;    
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
  
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
  vLd(3,:)=Ld(3,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{11}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
Jv = Jv + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 
        end;
      
   end;
   
 %Xt(33,:)=vLd(3,:);

end;

if(1)
%----------- knock-out plant: sav3-KO -----
%*** D_pKO8: sav CL 130uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  
 %DATA.photop=2; %define photoperiod 0: dark; 1: 16:8(L:D); 2: continuous light;  
  DATA.lux = 130; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)
  
 
  %---continuous:
  DATA.DN = inline('1.0*interp1([0 0.5 8.5 9 24],[1 1 1 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
Dbottom(:,[1,4])=DATA.Dbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.Dtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.Din*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.Dout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;
  
   %*** effect of mutation sav3
DATA.mu=DATA.savmu; 

  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;
  
   [Ct, state] = growth(T, Paramod,init0);
  
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
  vLd=Ld(:,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{12}))
      Xtarget = DATA.Xtarget{12}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{12}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
Jv = Jv + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2; 
        end;
      end;
   end;
 
 %Xt(34,:)=vLd(1,:);
 %Xt(35,:)=vLd(2,:);
 
 %*** C_pKO8: sav3 CL 130uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;    
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
  
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
  vLd(3,:)=Ld(3,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{12}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
Jv = Jv + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 
        end;
      
   end;
   
 %Xt(36,:)=vLd(3,:);

end;

%%%%%%%%%%%%%%%%%%%%%%%%%%% LD75

if(1) 
  %*** A_pKO1_2: Col_0 LD 75uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  
 %DATA.photop=2; %define photoperiod 0: dark; 1: 16:8(L:D); 2: continuous light;  
  DATA.lux = 75; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)
  %---LD:
  DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
%*** init: A=AAI at each cell

  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
Dbottom(:,[1,4])=DATA.Dbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.Dtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.Din*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.Dout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;
  DATA.mu=DATA.wtmu;
  %quantity=sum(sum(A0.*l));
%*** 

  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;

   [Ct, state] = growth(T, Paramod,init0);
  
	
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);

  vLd=Ld(:,end:-1:1);
  
  %weight=0.1; %1e-3; %1e-31;

%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{13}))
      Xtarget = DATA.Xtarget{13}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{13}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2; 
        end;
      end;
   end;
   
 %Xt(37,:)=vLd(1,:);
 %Xt(38,:)=vLd(2,:);
 
 %*** A_pKO1_2: Col_0 LD 75uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;   
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
  vLd(3,:)=Ld(3,end:-1:1);


%*** calculate the cost-function (for every Xtarget which <> NaN):
if (~isempty(DATA.Xtarget{13}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
J = J + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 
        end;
      
   end;
    %************************
  %plot(1:20,DATA.A_pKO1_2(1,:),'b*',1:20,vLd(1,:),1:20,DATA.A_pKO1_2(2,:),'g*',1:20,vLd(2,:),1:20,DATA.A_pKO1_2(3,:),'r*',1:20,vLd(3,:));
%************************

 %Xt(39,:)=vLd(3,:);
end;



if(1)
%----------- knock-out plant: abcb1/abcb19-KO -----
%*** C_pKO2: abcb LD 75uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  
 %DATA.photop=2; %define photoperiod 0: dark; 1: 16:8(L:D); 2: continuous light;  
  DATA.lux = 75; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)

  %---LD:
  DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
%*** init: A=AAI at each cell

  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
Dbottom(:,[1,4])=DATA.abcbDbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.abcbDtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.abcbDin*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.abcbDout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;
  
  %*** effect of mutation abcb 
  DATA.mu=DATA.abcbmu;
  
  
  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;
  
   [Ct, state] = growth(T, Paramod,init0);
  
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
   vLd=Ld(:,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{15}))
      Xtarget = DATA.Xtarget{15}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{15}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
Jv = Jv + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2; 
        end;
      end;
   end;
 
 %Xt(43,:)=vLd(1,:);
 %Xt(44,:)=vLd(2,:);
 
 %*** C_pKO2: abcb LD 75uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;    
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
    
  luxDN = DATA.DN(T).*DATA.lux;
  
  

  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
  vLd(3,:)=Ld(3,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{15}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
Jv = Jv + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 
        end;
      
   end;
   
 %Xt(45,:)=vLd(3,:);
%DATA.mu=Pold(1); %restaure mu0
 end;


if(1)
%----------- knock-out plant: sav3-KO -----
%*** D_pKO9: sav LD 75uE  ----------------------

  T = 0:DATA.dtime:DATA.Tsim;  
 %DATA.photop=2; %define photoperiod 0: dark; 1: 16:8(L:D); 2: continuous light;  
  DATA.lux = 75; % umol.m-2.s-1 Light intensity   
  DATA.delayFR=7*24; % time (h) when adding FR (before FR=1)
  
 
  %---LD:
  DATA.DN = inline('1.0*interp1([0 0.3 8 8.5 9 24],[0.3 0 0 .7 1 1],rem(x,24))','x');   
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  A0     = zeros(DATA.N,4);
  A0(:,:)=DATA.A0;
  l0 = ones(DATA.N,4)*DATA.linit; % /DATA.factlg ;
Dbottom(:,[1,4])=DATA.Dbottom*ones(DATA.N,2);% epiderm and endoderm
Dbottom(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
Dtop(:,[1,4])=DATA.Dtop*ones(DATA.N,2);%epiderm and endoderm
Dtop(:,2:3)=DATA.Dcortex*ones(DATA.N,2);% cortex
 Din=DATA.Din*ones(DATA.N,4);
 Din(:,3)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 Dout=DATA.Dout*ones(DATA.N,4);
 Dout(:,2)=DATA.Dcortex*ones(DATA.N,1);%between cortex cells
 D=cat(3,Dtop,Dbottom,Dout,Din);
  cuml0=DATA.Qlight0;

  %*** effect of mutation sav3
  DATA.mu=DATA.savmu;

  init0{1}=A0;
  init0{2}=l0;
  init0{3}=D;
  init0{4}=cuml0;
  
   [Ct, state] = growth(T, Paramod,init0);
  
  Ld(1,:)=Ct(find(round(T,1)==96),:);
  Ld(2,:)=Ct(find(round(T,1)==144),:);
  vLd=Ld(:,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{16}))
      Xtarget = DATA.Xtarget{16}(:,1:DATA.N-1);
      Wtarget = DATA.Wtarget{16}(:,1:DATA.N-1);
      for i=1:2
        p = find(~isnan(Xtarget(i,:)));
        if (~isempty(p))
Jv = Jv + DATA.dtime * (norm(sqrt(Wtarget(i,p)).*(Xtarget(i,p)-vLd(i,p))./Xtarget(i,p)))^2; 
        end;
      end;
   end;
 
 %Xt(46,:)=vLd(1,:);
 %Xt(47,:)=vLd(2,:);
 
 %*** C_pKO8: sav3 LD 75uE  + 2d in FR ----------------------

  T = 96:DATA.dtime:DATA.Tsim;    
  DATA.delayFR=4*24; % time (h) when adding FR (before FR=1)
     
  luxDN = DATA.DN(T).*DATA.lux;
  
  % Initial state: Default
  
  [Ct, statend] = growth(T, Paramod,state);
  
  Ld(3,:)=Ct(find(round(T,1)==144),:);
  vLd(3,:)=Ld(3,end:-1:1);
  
%*** calculate the cost-function (for every Xtarget which <> NaN):
   if (~isempty(DATA.Xtarget{16}))
        p = find(~isnan(Xtarget(3,:)));
        if (~isempty(p))
Jv = Jv + DATA.dtime * (norm(sqrt(Wtarget(3,p)).*(Xtarget(3,p)-vLd(3,p))./Xtarget(3,p)))^2; 
        end;
      
   end;
   
 %Xt(48,:)=vLd(3,:);


end;

Jneg=[Jneg,J];
JnegV=[JnegV,Jv];
fprintf('=== end +/- :\n');
end; %boil +/- boucle
fprintf('=== next param :\n');
Xt(s,:)=[s,Paramod(s),Jneg,JnegV];
end; %Param boucle


save -ascii J1perc_Hyp3_8_final_All.txt Xt


